#!/usr/bin/python
# -*- coding:utf8 -*-

""" Des fonctions utilitaire pour savoir si on est dans tel ou tel cas. """

import re
import time

import config

def regex_join(liste, avant=u".*(?:^| )", apres=u"(?:$|\.| |,|;).*"):
    """Fabrique une regexp à partir d'une liste d'éléments à matcher."""
    return avant + u"(" + u"|".join(liste) + u")" + apres

def is_something(chain, regexp=None, matches=[], avant=u".*(?:^| )", apres=u"(?:$|\.| |,|;).*",
                 case_sensitive=False):
    """Vérifie si chain contient un des éléments de ``matches``.
       Si ``regexp`` est fournie, c'est simplement elle qui est testée"""
    if not case_sensitive:
        chain = chain.lower()
        apres = apres.lower()
        avant = avant.lower()
    if regexp == None:
        regexp = regex_join(matches, avant, apres)
        regexp = re.compile(regexp)
    o = regexp.match(chain)
    return o

def regexp_compile():
    """Compilation des regexp à partir de la conf.
       Place les résultats dans le namespace de ``config``"""
    config.allah_regexp = regex_join(config.allah_triggers, avant=".*", apres="$")
    config.allah_regexp_compiled = re.compile(config.allah_regexp)

    config.tag_regexp = regex_join(config.tag_triggers, avant=".*", apres="$")
    config.tag_regexp_compiled = re.compile(config.tag_regexp)
    
    
regexp_compile()
def is_tag(chain):
    """Vérifie si ``chain`` demande de fermer sa gueule."""
    return is_something(chain, config.tag_regexp_compiled)

def is_allah(chain):
    """Vérifie si ``chain``est du allah-spam."""
    return is_something(chain, config.allah_regexp_compiled)
